# GstDeviceProviderFactory

GstDeviceProviderFactory is used to create instances of device providers. A GstDeviceProviderfactory can be added to a GstPlugin as it is also a GstPluginFeature.

Use the gst_device_provider_factory_find and gst_device_provider_factory_get functions to create device provider instances or use gst_device_provider_factory_get_by_name as a convenient shortcut.

## GstDeviceProviderFactory

    GObject
        ╰──GInitiallyUnowned
            ╰──GstObject
                ╰──GstPluginFeature
                    ╰──GstDeviceProviderFactory

The opaque GstDeviceProviderFactory data structure.

Since : 1.4

### Class structure

#### GstDeviceProviderFactoryClass

The opaque GstDeviceProviderFactoryClass data structure.

Since : 1.4

### Gst.DeviceProviderFactoryClass

The opaque Gst.DeviceProviderFactoryClass data structure.

Since : 1.4

### Gst.DeviceProviderFactoryClass

The opaque Gst.DeviceProviderFactoryClass data structure.

Since : 1.4

## Gst.DeviceProviderFactory

    GObject.Object
        ╰──GObject.InitiallyUnowned
            ╰──Gst.Object
                ╰──Gst.PluginFeature
                    ╰──Gst.DeviceProviderFactory

The opaque Gst.DeviceProviderFactory data structure.

Since : 1.4

## Gst.DeviceProviderFactory

    GObject.Object
        ╰──GObject.InitiallyUnowned
            ╰──Gst.Object
                ╰──Gst.PluginFeature
                    ╰──Gst.DeviceProviderFactory

The opaque Gst.DeviceProviderFactory data structure.

Since : 1.4

### Methods

#### gst_device_provider_factory_get

    GstDeviceProvider *
    gst_device_provider_factory_get (GstDeviceProviderFactory * factory)

Returns the device provider of the type defined by the given device providerfactory.

Parameters:

`factory` –

factory to instantiate

Returns ( [transfer: full][nullable]) –

the GstDeviceProvider or NULL if the device provider couldn't be created

Since : 1.4

#### Gst.DeviceProviderFactory.prototype.get

    function Gst.DeviceProviderFactory.prototype.get(): {
        // javascript wrapper for 'gst_device_provider_factory_get'
    }

Returns the device provider of the type defined by the given device providerfactory.

Parameters:

`factory` (Gst.DeviceProviderFactory) –

factory to instantiate

Returns (Gst.DeviceProvider) –

the Gst.DeviceProvider or NULL if the device provider couldn't be created

Since : 1.4

#### Gst.DeviceProviderFactory.get

    def Gst.DeviceProviderFactory.get (self):
        #python wrapper for 'gst_device_provider_factory_get'

Returns the device provider of the type defined by the given device providerfactory.

Parameters:

`factory` (Gst.DeviceProviderFactory) –

factory to instantiate

Returns (Gst.DeviceProvider) –

the Gst.DeviceProvider or NULL if the device provider couldn't be created

Since : 1.4

#### gst_device_provider_factory_get_device_provider_type

    GType
    gst_device_provider_factory_get_device_provider_type (GstDeviceProviderFactory * factory)

Get the GType for device providers managed by this factory. The type can only be retrieved if the device provider factory is loaded, which can be assured with gst_plugin_feature_load.

Parameters:

`factory` –

factory to get managed GType from

Returns –

the GType for device providers managed by this factory.

Since : 1.4

#### Gst.DeviceProviderFactory.prototype.get_device_provider_type

    function Gst.DeviceProviderFactory.prototype.get_device_provider_type(): {
        // javascript wrapper for 'gst_device_provider_factory_get_device_provider_type'
    }

Get the GObject.Type for device providers managed by this factory. The type can only be retrieved if the device provider factory is loaded, which can be assured with Gst.PluginFeature.prototype.load.

Parameters:

`factory` (Gst.DeviceProviderFactory) –

factory to get managed GObject.Type from

Returns (GObject.Type) –

the GObject.Type for device providers managed by this factory.

Since : 1.4

#### Gst.DeviceProviderFactory.get_device_provider_type

    def Gst.DeviceProviderFactory.get_device_provider_type (self):
        #python wrapper for 'gst_device_provider_factory_get_device_provider_type'

Get the GObject.Type for device providers managed by this factory. The type can only be retrieved if the device provider factory is loaded, which can be assured with Gst.PluginFeature.load.

Parameters:

`factory` (Gst.DeviceProviderFactory) –

factory to get managed GObject.Type from

Returns (GObject.Type) –

the GObject.Type for device providers managed by this factory.

Since : 1.4

#### gst_device_provider_factory_get_metadata

    const gchar*
    gst_device_provider_factory_get_metadata (GstDeviceProviderFactory * factory,
                                              const gchar* key)

Get the metadata on factory with key.

Parameters:

`factory` –

a GstDeviceProviderFactory

`key` –

a key

Returns ( [nullable]) –

the metadata with key on factory or NULL when there was no metadata with the given key.

Since : 1.4

#### Gst.DeviceProviderFactory.prototype.get_metadata

    function Gst.DeviceProviderFactory.prototype.get_metadata(key: String): {
        // javascript wrapper for 'gst_device_provider_factory_get_metadata'
    }

Get the metadata on factory with key.

Parameters:

`factory` (Gst.DeviceProviderFactory) –

a Gst.DeviceProviderFactory

`key` (String) –

a key

Returns (String) –

the metadata with key on factory or NULL when there was no metadata with the given key.

Since : 1.4

#### Gst.DeviceProviderFactory.get_metadata

    def Gst.DeviceProviderFactory.get_metadata (self, key):
        #python wrapper for 'gst_device_provider_factory_get_metadata'

Get the metadata on factory with key.

Parameters:

`factory` (Gst.DeviceProviderFactory) –

a Gst.DeviceProviderFactory

`key` (str) –

a key

Returns (str) –

the metadata with key on factory or NULL when there was no metadata with the given key.

Since : 1.4

#### gst_device_provider_factory_get_metadata_keys

    gchar**
    gst_device_provider_factory_get_metadata_keys (GstDeviceProviderFactory * factory)

Get the available keys for the metadata on factory.

Parameters:

`factory` –

a GstDeviceProviderFactory

Returns –

(transfer full) (element-type utf8) (array zero-terminated=1) (nullable): a NULL-terminated array of key strings, or NULL when there is no metadata. Free with g_strfreev when no longer needed.

Since : 1.4

#### Gst.DeviceProviderFactory.prototype.get_metadata_keys

    function Gst.DeviceProviderFactory.prototype.get_metadata_keys(): {
        // javascript wrapper for 'gst_device_provider_factory_get_metadata_keys'
    }

Get the available keys for the metadata on factory.

Parameters:

`factory` (Gst.DeviceProviderFactory) –

a Gst.DeviceProviderFactory

Returns ([ String ]) –

(transfer full) (element-type utf8) (array zero-terminated=1) (nullable): a NULL-terminated array of key strings, or NULL when there is no metadata. Free with GLib.prototype.strfreev when no longer needed.

Since : 1.4

#### Gst.DeviceProviderFactory.get_metadata_keys

    def Gst.DeviceProviderFactory.get_metadata_keys (self):
        #python wrapper for 'gst_device_provider_factory_get_metadata_keys'

Get the available keys for the metadata on factory.

Parameters:

`factory` (Gst.DeviceProviderFactory) –

a Gst.DeviceProviderFactory

Returns ([ str ]) –

(transfer full) (element-type utf8) (array zero-terminated=1) (nullable): a NULL-terminated array of key strings, or NULL when there is no metadata. Free with GLib.strfreev when no longer needed.

Since : 1.4

#### gst_device_provider_factory_has_classes

    gboolean
    gst_device_provider_factory_has_classes (GstDeviceProviderFactory * factory,
                                             const gchar* classes)

Check if factory matches all of the given classes

Parameters:

`factory` –

a GstDeviceProviderFactory

`classes` ( [allow-none]) –

a "/" separate list of classes to match, only match if all classes are matched

Returns –

TRUE if factory matches or if classes is NULL.

Since : 1.4

#### Gst.DeviceProviderFactory.prototype.has_classes

    function Gst.DeviceProviderFactory.prototype.has_classes(classes: String): {
        // javascript wrapper for 'gst_device_provider_factory_has_classes'
    }

Check if factory matches all of the given classes

Parameters:

`factory` (Gst.DeviceProviderFactory) –

a Gst.DeviceProviderFactory

`classes` (String) –

a "/" separate list of classes to match, only match if all classes are matched

Returns (Number) –

TRUE if factory matches or if classes is NULL.

Since : 1.4

#### Gst.DeviceProviderFactory.has_classes

    def Gst.DeviceProviderFactory.has_classes (self, classes):
        #python wrapper for 'gst_device_provider_factory_has_classes'

Check if factory matches all of the given classes

Parameters:

`factory` (Gst.DeviceProviderFactory) –

a Gst.DeviceProviderFactory

`classes` (str) –

a "/" separate list of classes to match, only match if all classes are matched

Returns (bool) –

TRUE if factory matches or if classes is NULL.

Since : 1.4

#### gst_device_provider_factory_has_classesv

    gboolean
    gst_device_provider_factory_has_classesv (GstDeviceProviderFactory * factory,
                                              gchar** classes)

Check if factory matches all of the given classes

Parameters:

`factory` –

a GstDeviceProviderFactory

`classes` ( [arrayzero-terminated=1][allow-none]) –

a NULL terminated array of classes to match, only match if all classes are matched

Returns –

TRUE if factory matches.

Since : 1.4

#### Gst.DeviceProviderFactory.prototype.has_classesv

    function Gst.DeviceProviderFactory.prototype.has_classesv(classes: [ String ]): {
        // javascript wrapper for 'gst_device_provider_factory_has_classesv'
    }

Check if factory matches all of the given classes

Parameters:

`factory` (Gst.DeviceProviderFactory) –

a Gst.DeviceProviderFactory

`classes` ([ String ]) –

a NULL terminated array of classes to match, only match if all classes are matched

Returns (Number) –

TRUE if factory matches.

Since : 1.4

#### Gst.DeviceProviderFactory.has_classesv

    def Gst.DeviceProviderFactory.has_classesv (self, classes):
        #python wrapper for 'gst_device_provider_factory_has_classesv'

Check if factory matches all of the given classes

Parameters:

`factory` (Gst.DeviceProviderFactory) –

a Gst.DeviceProviderFactory

`classes` ([ str ]) –

a NULL terminated array of classes to match, only match if all classes are matched

Returns (bool) –

TRUE if factory matches.

Since : 1.4

### Functions

#### gst_device_provider_factory_find

    GstDeviceProviderFactory *
    gst_device_provider_factory_find (const gchar* name)

Search for an device provider factory of the given name. Refs the returned device provider factory; caller is responsible for unreffing.

Parameters:

`name` –

name of factory to find

Returns ( [transfer: full][nullable]) –

GstDeviceProviderFactory if found, NULL otherwise

Since : 1.4

#### Gst.DeviceProviderFactory.prototype.find

    function Gst.DeviceProviderFactory.prototype.find(name: String): {
        // javascript wrapper for 'gst_device_provider_factory_find'
    }

Search for an device provider factory of the given name. Refs the returned device provider factory; caller is responsible for unreffing.

Parameters:

`name` (String) –

name of factory to find

Returns (Gst.DeviceProviderFactory) –

Gst.DeviceProviderFactory if found, NULL otherwise

Since : 1.4

#### Gst.DeviceProviderFactory.find

    def Gst.DeviceProviderFactory.find (name):
        #python wrapper for 'gst_device_provider_factory_find'

Search for an device provider factory of the given name. Refs the returned device provider factory; caller is responsible for unreffing.

Parameters:

`name` (str) –

name of factory to find

Returns (Gst.DeviceProviderFactory) –

Gst.DeviceProviderFactory if found, NULL otherwise

Since : 1.4

#### gst_device_provider_factory_get_by_name

    GstDeviceProvider *
    gst_device_provider_factory_get_by_name (const gchar* factoryname)

Returns the device provider of the type defined by the given device provider factory.

Parameters:

`factoryname` –

a named factory to instantiate

Returns ( [transfer: full][nullable]) –

a GstDeviceProvider or NULL if unable to create device provider

Since : 1.4

#### Gst.DeviceProviderFactory.prototype.get_by_name

    function Gst.DeviceProviderFactory.prototype.get_by_name(factoryname: String): {
        // javascript wrapper for 'gst_device_provider_factory_get_by_name'
    }

Returns the device provider of the type defined by the given device provider factory.

Parameters:

`factoryname` (String) –

a named factory to instantiate

Returns (Gst.DeviceProvider) –

a Gst.DeviceProvider or NULL if unable to create device provider

Since : 1.4

#### Gst.DeviceProviderFactory.get_by_name

    def Gst.DeviceProviderFactory.get_by_name (factoryname):
        #python wrapper for 'gst_device_provider_factory_get_by_name'

Returns the device provider of the type defined by the given device provider factory.

Parameters:

`factoryname` (str) –

a named factory to instantiate

Returns (Gst.DeviceProvider) –

a Gst.DeviceProvider or NULL if unable to create device provider

Since : 1.4

#### gst_device_provider_factory_list_get_device_providers

    GList *
    gst_device_provider_factory_list_get_device_providers (GstRank minrank)

Get a list of factories with a rank greater or equal to minrank. The list of factories is returned by decreasing rank.

Parameters:

`minrank` –

Minimum rank

Returns –

(transfer full) (element-type Gst.DeviceProviderFactory): a GList of GstDeviceProviderFactory device providers. Use gst_plugin_feature_list_free after usage.

Since : 1.4

#### Gst.DeviceProviderFactory.prototype.list_get_device_providers

    function Gst.DeviceProviderFactory.prototype.list_get_device_providers(minrank: Gst.Rank): {
        // javascript wrapper for 'gst_device_provider_factory_list_get_device_providers'
    }

Get a list of factories with a rank greater or equal to minrank. The list of factories is returned by decreasing rank.

Parameters:

`minrank` (Gst.Rank) –

Minimum rank

Returns ([ Gst.DeviceProviderFactory ]) –

(transfer full) (element-type Gst.DeviceProviderFactory): a GLib.List of Gst.DeviceProviderFactory device providers. Use Gst.PluginFeature.prototype.list_free after usage.

Since : 1.4

#### Gst.DeviceProviderFactory.list_get_device_providers

    def Gst.DeviceProviderFactory.list_get_device_providers (minrank):
        #python wrapper for 'gst_device_provider_factory_list_get_device_providers'

Get a list of factories with a rank greater or equal to minrank. The list of factories is returned by decreasing rank.

Parameters:

`minrank` (Gst.Rank) –

Minimum rank

Returns ([ Gst.DeviceProviderFactory ]) –

(transfer full) (element-type Gst.DeviceProviderFactory): a GLib.List of Gst.DeviceProviderFactory device providers. Use Gst.PluginFeature.list_free after usage.

Since : 1.4

## Function Macros

### GST_DEVICE_PROVIDER_FACTORY_CAST

    #define GST_DEVICE_PROVIDER_FACTORY_CAST(obj)       ((GstDeviceProviderFactory *)(obj))

The results of the search are